#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_BankGiftCFG.h"
std::auto_ptr<M_BankGiftCFG> M_BankGiftCFG::msSingleton(nullptr);

int M_BankGiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_BankGiftCFGData* M_BankGiftCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_BankGiftCFGData>& M_BankGiftCFG::GetMapData()
{
	return mMapData;
}

void M_BankGiftCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_BankGiftCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_BankGiftCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* RechangId = element->Attribute("RechangId");
			std::vector<std::string> vecRechangId;
			boost::split(vecRechangId, RechangId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRechangId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRechangId[i].c_str(), &temp))
				{
					data.mRechangId.push_back(temp);
				}
			}
		}
		data.mWeight = element->IntAttribute("Weight");
		data.mMultiple = element->IntAttribute("Multiple");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_BankGiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_BankGiftCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_BankGiftCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_BankGiftCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_BankGiftCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "RechangId", data.mRechangId);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "Multiple", data.mMultiple);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_BankGiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_BankGiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_BankGiftCFG* M_BankGiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_BankGiftCFG());
	}
	return msSingleton.get();
}

void M_BankGiftCFG::Release()
{
	msSingleton.reset(nullptr);
}
